import sys
import random
import thread
from ichrome import GRAPH
from ichrome import API


# Common global variables
vPad = 0.0
running = True

# PAD controller loop 
def controller():
    global running
    global vPad

    while running:
        ch = API.pause()
        if ch=='e':        # 'e' pressed => EXIT GAME
            running = False
        elif ch=='a':
            vPad = -1.25   # 'a' pressed => move RIGHT
        elif ch =='s':
            vPad =  1.15   # 's' pressed => move LEFT
    return

# initial settings, PAD in the middle, random direction
xPad = 0.5
v = [ random.random(), 1.0 ]
x = [ random.random(), 1.0 ] 
dt = 0.015

# Create support table, view and columns
table = GRAPH.createTable("field",True)
cols = [
   table.createColumn("X",   "double"),
   table.createColumn("Y",   "double"),
   table.createColumn("XPAD","double"),
   table.createColumn("ypad","double") ]
view = table.getView()
row = table.createRow()

# use a separate thread for PAD controller
thread.start_new_thread( controller, () )

# define main moving loop (control BALL and PAD)
i = 0
while running:
    # increase speed (every 50 steps)
    i = i+1
    if i%50==0:
        dt *= 1.05
        
    # BALL position (and wall-hit checks)
    for k in xrange(0,2):
        x[k] += v[k]*dt
        
        if x[k]>1:
            x[k] = 1.0
            v[k] *= -1.0 + 0.1 * (0.5-random.random())
        
        if x[k]<0:
            if k==1:
                running = (abs(xPad-x[0])<0.075)
            
            x[k] = 0.0;
            v[k] *= -1.0 + 0.1 * (0.5-random.random())
            
        row.setValue(cols[k], x[k]);

    # game PAD position       
    xPad += vPad * dt
    if xPad>1:
        xPad = 1
    elif xPad<0:
        xPad = 0

    row.setValue(cols[2], xPad)
    row.setValue(cols[3], -.05)
    API.sleep(0.10)
    
print("GAME OVER!!!")
API.save()